OpenVDB: DenseBase< ValueT, LayoutZYX > Class Template Reference

OpenVDB 3.1.0

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
DenseBase< ValueT, LayoutZYX > Class Template Reference

Partial template specialization of DenseBase. More...

`#include <Dense.h>`

## Public Member Functions
size_t | coordToOffset (size_t i, size_t j, size_t k) const
| Return the linear offset into this grid's value array given by unsigned coordinates (i, j, k), i.e., coordinates relative to the origin of this grid's bounding box. More...
Coord | offsetToLocalCoord (size_t n) const
| Return the local coordinate corresponding to the specified linear offset. More...
size_t | xStride () const
| Return the stride of the array in the x direction ( = dimY*dimZ). More...
size_t | yStride () const
| Return the stride of the array in the y direction ( = dimZ). More...

## Static Public Member Functions
static size_t | zStride ()
| Return the stride of the array in the z direction ( = 1). More...

## Protected Member Functions
| DenseBase (const CoordBBox &bbox)
| Protected constructor so as to prevent direct instantiation. More...

## Protected Attributes
const CoordBBox | mBBox
const size_t | mY
const size_t | mX

## Detailed Description

### template<typename ValueT>
class openvdb::v3_1_0::tools::DenseBase< ValueT, LayoutZYX >

Partial template specialization of DenseBase.

Note
  ZYX is the memory-layout in VDB. It leads to nested for-loops of the order x, y, z which we find to be the most intuitive.

## Constructor & Destructor Documentation

DenseBase | ( | const CoordBBox & | bbox | ) |
| inlineprotected

Protected constructor so as to prevent direct instantiation.

## Member Function Documentation

size_t coordToOffset | ( | size_t | i,
|  | size_t | j,
|  | size_t | k
| ) |  | const
| inline

Return the linear offset into this grid's value array given by unsigned coordinates (i, j, k), i.e., coordinates relative to the origin of this grid's bounding box.

Warning
  The input coordinates are assume to be relative to the grid's origin, i.e. minimum of its index bounding box!

Coord offsetToLocalCoord | ( | size_t | n | ) | const
| inline

Return the local coordinate corresponding to the specified linear offset.

Warning
  The returned coordinate is relative to the origin of this grid's bounding box so add dense.origin() to get absolute coordinates.

size_t xStride | ( |  | ) | const
| inline

Return the stride of the array in the x direction ( = dimY*dimZ).

Note
  This method is required by both CopyToDense and CopyFromDense.

size_t yStride | ( |  | ) | const
| inline

Return the stride of the array in the y direction ( = dimZ).

Note
  This method is required by both CopyToDense and CopyFromDense.

static size_t zStride | ( |  | ) |
| inlinestatic

Return the stride of the array in the z direction ( = 1).

Note
  This method is required by both CopyToDense and CopyFromDense.

## Member Data Documentation

const CoordBBox mBBox
| protected

const size_t mX
| protected

const size_t mY
| protected

The documentation for this class was generated from the following file:

- Dense.h